---
title: HTMLFormElement.requestSubmit()
slug: Web/API/HTMLFormElement/requestSubmit
tags:
  - API
  - HTML
  - HTML DOM
  - HTMLFormElement
  - Input
  - Method
  - button
  - form
  - requestSubmit
  - submit
---
<p>{{APIRef("HTML DOM")}}</p>

<p><span class="seoSummary">The {{domxref("HTMLFormElement")}} method <code><strong>requestSubmit()</strong></code> requests that the form be submitted using a specific submit button.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var>htmlFormElement</var>.requestSubmit(<var>submitter</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>submitter</var></code> {{optional_inline}}</dt>
 <dd>
 <p>The submit button whose attributes describe the method by which the form is to be submitted. This may be either an {{HTMLElement("input")}} or {{HTMLElement("button")}} element whose <code>type</code> attribute is <code>submit</code>.</p>

 <p>If you omit the <code><var>submitter</var></code> parameter, the form element itself is used as the submitter.</p>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>TypeError</code></dt>
 <dd>The specified <code><var>submitter</var></code> is not a submit button.</dd>
 <dt><code>NotFoundError</code></dt>
 <dd>The specified <code><var>submitter</var></code> isn't a member of the form on which <code>requestSubmit()</code> was called. The submitter must be either a descendant of the form element or must have an {{htmlattrxref("form", "input")}} attribute referring to the form.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>The obvious question is: Why does this method exist, when we've had the {{domxref("HTMLFormElement.submit", "submit()")}} method since the dawn of time?</p>

<p>The answer is simple. <code>submit()</code> submits the form, but that's all it does. <code>requestSubmit()</code>, on the other hand, acts as if a submit button were clicked. The form's content is validated, and the form is submitted only if validation succeeds. Once the form has been submitted, the {{domxref("HTMLFormElement.submit_event", "submit")}} event is sent back to the form object.</p>

<h2 id="Examples">Examples</h2>

<p>In the example below, the form is submitted by attempting to send the request using <code>requestSubmit()</code> if it's available. If a submit button with the ID <code>main-submit</code> is found, that's used to submit the form. Otherwise, the form is submitted with no <code>submitter</code> parameter, so it's submitted directly by the form itself.</p>

<p>If, on the other hand, <code>requestSubmit()</code> isn't available, this code falls back to calling the form's {{domxref("HTMLFormElement.submit", "submit()")}} method.</p>

<pre class="brush: js">let myForm = document.querySelector("form");
let submitButton = myForm.querySelector("#main-submit");

if (myForm.requestSubmit) {
  if (submitButton) {
    myForm.requestSubmit(submitButton);
  } else {
    myForm.requestSubmit();
  }
} else {
  myForm.submit();
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#dom-form-requestsubmit", "requestSubmit()")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.HTMLFormElement.requestSubmit")}}</p>
